class bad
{
public:
  bad(void);                  // default constructor
  bad(const bad&);            // copy constructor
  ~bad(void);                 // destructor
  bad& operator=(const bad&); // copy assignment
private:
  int* pi;
};

bad::bad(void)
  : pi(new int(5)) // allocate new int on heap and 
                   // give it the value 5.
{}

bad::bad(const bad& b)
  : pi(b.pi) // initialize pi with the value of b's pi
{           // This is very bad, as you will soon see
}

bad::~bad(void)
{
  delete pi;
}

bad& bad::operator=(const bad& b)
{
  pi = b.pi;   // This seamingly logical and simple 
  return *this; // assignment is also disasterous.
}

int main(void)
{
  bad b1;
  {
    bad b2(b1); // b2.pi is now the same as b1.pi.
  } // Here b2 is destroyed, and b2's destructor is
    // called. This means that the memory area
    // pointed to by b2.pi (and hence also b1.pi) is
    // no longer valid

  bad b3(b1); // Make b3.pi point to the same invalid         
              // memory area!
  bad b4;
  bad b5;
  b5 = b4; // The memory allocated by b5 was never
           // deallocated. We have a memory leak!
  return 0;
} // The destrctor of b1 and b3 attempt to deallocate
  // the memory already dealloceted by the destructor
  // of b2. The destructors of b4 and b5 both attempt
  // to deallocate the same memory (b5 first,
  // correctly so, and then b4, which deallocates 
  // already deallocated memory.
