
package macrolanguage;

import java.awt.*;
import java.awt.event.*;
import macrolanguage.FreeFormEdit;
import macrolanguage.NotAContainerException;
import java.util.Hashtable;
import macrolanguage.ComponentWrapper;
import macrolanguage.ProjectSettings;

/**
 * this class is a part of FreeFormEdit torn out to allow a more dynamic
 * design, rather than concentrating all the events into one class I removed
 * all the mouse events to a separate class.
 * 
 * ATTENTION:
 * most of the method in this class are deprecated. They were used in the previos article
 * but are no longer in use in this article.
**/
public class MouseManager implements MouseListener, MouseMotionListener
{
		private Point lastMousePosition = new Point();

		private FreeFormEdit client; // the owning FreeFormEdit.

		/**
		 * The constructor needs a pointer to it's FreeFormEdit owner
		 * so it will be able to respond to it's events with callback
		 * for methods.
		**/
		MouseManager(FreeFormEdit client)
		{
				this.client = client;

				// insert values of the cursor shape into a hash table.
				ProjectSettings.resizePossibleStates.put(new Integer(ProjectSettings.NO_RESIZE), new Integer(Cursor.DEFAULT_CURSOR));
				ProjectSettings.resizePossibleStates.put(new Integer(ProjectSettings.RESIZE_UP), new Integer(Cursor.N_RESIZE_CURSOR));
				ProjectSettings.resizePossibleStates.put(new Integer(ProjectSettings.RESIZE_DOWN), new Integer(Cursor.S_RESIZE_CURSOR));
				ProjectSettings.resizePossibleStates.put(new Integer(ProjectSettings.RESIZE_LEFT), new Integer(Cursor.W_RESIZE_CURSOR));
				ProjectSettings.resizePossibleStates.put(new Integer(ProjectSettings.RESIZE_RIGHT), new Integer(Cursor.E_RESIZE_CURSOR));
				ProjectSettings.resizePossibleStates.put(new Integer(ProjectSettings.RESIZE_UP   | ProjectSettings.RESIZE_LEFT), new Integer(Cursor.NW_RESIZE_CURSOR));
				ProjectSettings.resizePossibleStates.put(new Integer(ProjectSettings.RESIZE_DOWN | ProjectSettings.RESIZE_LEFT), new Integer(Cursor.SW_RESIZE_CURSOR));
				ProjectSettings.resizePossibleStates.put(new Integer(ProjectSettings.RESIZE_UP   | ProjectSettings.RESIZE_RIGHT), new Integer(Cursor.NE_RESIZE_CURSOR));
				ProjectSettings.resizePossibleStates.put(new Integer(ProjectSettings.RESIZE_DOWN | ProjectSettings.RESIZE_RIGHT), new Integer(Cursor.SE_RESIZE_CURSOR));

		}
		/**
		 * this method recives a component ,a container and an x,y coordinate.
		 * When a mouse event is recived we get a relative x,y coordinate to the
		 * owning component and not the container, if we need an absolute position
		 * relative to the owning container we need to use this method.
		**/
		private Point calculateParentContainerXY(Component relativeComponent, Container owningContainer, int x, int y)
		{
				// if this is the owner component then return these coordinates.
				if(relativeComponent == owningContainer)
						return(new Point(x, y));
				Component c = relativeComponent.getParent();
				return(calculateParentContainerXY(c, owningContainer, relativeComponent.getLocation().x + x, relativeComponent.getLocation().y + y));
		}
		/**
		 * this method recives a point and a component to which the point
		 * is relative and calculates the same point relative to this Component.
		**/
		private Point calculateRelativePosition(Point pos, Component c)
		{
				// if the positions are negative then fix them into
				// positive absolute positions.
				if(pos.x < 0)
				{
						pos.x = c.getLocation().x + pos.x;
						if(pos.y >= 0)
						{
								pos.y = calculateParentContainerXY(c, client, pos.x, pos.y).y;
						}
						else
						{
								pos.y = c.getLocation().y + pos.y;
								pos.x = calculateParentContainerXY(c, client, pos.x, pos.y).x;
						}
						return(pos);
				}
				else
				if(pos.y < 0)
				{
						pos.y = c.getLocation().y; // + pos.y;
						return (new Point(pos.x,pos.y));
				}

				pos = calculateParentContainerXY(c, client, pos.x, pos.y);

				return(pos);
		}
		/**
		 * Called whenever a mouse gets dragged.
		**/
		private void componentDragged(java.awt.event.MouseEvent ev)
		{
				// remove the selection from the selected component to avoid
				// a trail.
				client.setSelection(client);

				// get the position of the event.
				Point pos = ev.getPoint();

				// get the source component of the event.
				Component c = (Component)ev.getSource();
				c.removeMouseMotionListener(this);

				ProjectSettings.dragMode = true;

				if(c instanceof ComponentWrapper)
				{
						// is the event generated by our owning FreeFormEdit instance?
						c.setLocation(calculateRelativePosition(pos, c));
				}
				else
				{
						if((c != client) && (c.getParent() instanceof ComponentWrapper))
						{ // if not:
								c.getParent().setLocation(calculateRelativePosition(pos, c));
						}
				}
				c.addMouseMotionListener(this);
		}
		/**
		 * gets called when a resize operation occurs on a component.
		**/
		private void componentResized(java.awt.event.MouseEvent ev)
		{
				// get the position of the event.
				Point pos = ev.getPoint();

				// get the source component of the event.
				Component c = (Component)ev.getSource();
				c.removeMouseMotionListener(this);

				if(c.getParent() instanceof ComponentWrapper)
						c = c.getParent();

				// is the event generated by our owning FreeFormEdit instance?
				if(c != client)
				{ // if not:
						Point loc = calculateRelativePosition(pos, c);
						if ((loc.x < c.getLocation().x + ProjectSettings.MINIMUM_COMPONENT_WIDTH) ||
							(loc.y < c.getLocation().y + ProjectSettings.MINIMUM_COMPONENT_HEIGHT))
								return;

						// if we have a horizontal resize mouse then we should
						// resize the y azis, if not we should leave it as before.
						if(((ProjectSettings.resizeMode & ProjectSettings.RESIZE_UP) != 0) || ((ProjectSettings.resizeMode & ProjectSettings.RESIZE_DOWN) != 0))
								loc.y = loc.y - c.getLocation().y;
						else
								if(c instanceof ComponentWrapper)
										loc.y = ((ComponentWrapper)c).getComponent().getSize().height;
								else
										loc.y = c.getSize().height;

						// if we have a vertical resize mouse then we should
						// resize the x azis, if not we should leave it as before.
						if(((ProjectSettings.resizeMode & ProjectSettings.RESIZE_LEFT) != 0) || ((ProjectSettings.resizeMode & ProjectSettings.RESIZE_RIGHT) != 0))
								loc.x = loc.x - c.getLocation().x;
						else
								if(c instanceof ComponentWrapper)
										loc.x = ((ComponentWrapper)c).getComponent().getSize().width;
								else
										loc.x = c.getSize().width;

						// check if the x asis is on the grid.
						if(loc.x % ProjectSettings.gridSize != 0)
								loc.x = (loc.x / ProjectSettings.gridSize) * (loc.x % ProjectSettings.gridSize);

						// check if the y asis is on the grid.
						if(loc.y % ProjectSettings.gridSize != 0)
								loc.y = (loc.y / ProjectSettings.gridSize) * (loc.y % ProjectSettings.gridSize);

						c.setSize(loc.x, loc.y);
				}
				c.addMouseMotionListener(this);
		}
		/**
		 * required by the MouseListener interface.
		 * When a mouse is clicked that could mean 2 things:
		 * 1. Selection of a component on the surface.
		 * 2. Dropping a new component onto the surface.
		**/
		public void mouseClicked(java.awt.event.MouseEvent ev)
		{
				// if we are in the midst of placeing a new component onto
				// the free edit surface.
				if(ProjectSettings.componentToPlace != null)
				{
						try
						{
								Component container = (Component)ev.getSource();

								if(container instanceof ComponentWrapper)
										container = ((ComponentWrapper)container).getComponent();

								// set the mouse cursor to the original cursor.
								client.setCursor(Cursor.getDefaultCursor());

								if(!(container instanceof Container))
										throw (new NotAContainerException(container.toString() + " is a Component"));

								ComponentWrapper wrapper = new ComponentWrapper(ProjectSettings.componentToPlace);

								// add the new component to the correct location.
								client.add(wrapper, ev.getPoint().x, ev.getPoint().y);

								// set the size of the component to the default size for all the components.
								wrapper.setSize(ProjectSettings.DEFAULT_COMPONENT_HEIGHT, ProjectSettings.DEFAULT_COMPONENT_WIDTH);

								// set the new component to be the selected component.
								client.setSelection(wrapper);

								// mark the fact that the component was placed.
								ProjectSettings.componentToPlace = null;
								return;
						}
						catch(NotAContainerException e)
						{
								System.out.println("Not a container. A component can only be placed in a container.");
						}
				}
		}
		/**
		 * This method is a part of the MouseMotionListener interface and is
		 * called whenever a mouse is dragged.
		 * This method abstracts the dragging and dropping of components
		 * on the free form surface.
		**/
		public void mouseDragged(java.awt.event.MouseEvent ev)
		{
		}
		/**
		 * required by the MouseMotionListener interface.
		**/
		public void mouseEntered(java.awt.event.MouseEvent ev)
		{
		}
		/**
		 * required by the MouseMotionListener interface.
		**/
		public void mouseExited(java.awt.event.MouseEvent ev)
		{
		}
		/**
		 * required by the MouseMotionListener interface.
		 * used to determin when to diplay the resize mouse pointer on the components.
		**/
		public void mouseMoved(java.awt.event.MouseEvent ev)
		{
				if (ProjectSettings.componentToPlace == null) 
	                client.setCursor(new Cursor(Cursor.DEFAULT_CURSOR));
		}
		/**
		 * required by the MouseListener interface.
		**/
		public void mousePressed(java.awt.event.MouseEvent ev)
		{
		}
		/**
		 * required by the MouseListener interface.
		 * The drop operation when dragging is implemented here.
		**/
		public void mouseReleased(java.awt.event.MouseEvent ev)
		{
		}
		/**
		 * places the component comp on the next click on the free form
		 * edit surface.
		**/
		public void placeComponentOnNextClick(Component comp)
		{
				ProjectSettings.componentToPlace = comp;
		}
}