
package macrolanguage;

import java.io.OutputStream;
import java.util.Vector;

/**
 * The SimpleStream class implements OutputStream and simply stores all that
 * is written to the output stream. It's purpose is to allow programms who 
 * only use text streams to implement the stream in a simple way.
**/
public class SimpleStream extends java.io.OutputStream
{
	private Vector stringsWritten = new Vector();

	/**
	 * the close method does nothing in this implementation.
	**/
	public void close()
	{
	}
	/**
	 * the flush method does nothing in this implementation.
	**/
	public void flush()
	{
	}
	/**
	 * returns a vector containing all the strings written to the stream.
	**/
	public Vector getStringsWritten()
	{
		return(stringsWritten);
	}
	/**
	 * save a string of data to the stream vector.
	**/
	public void write(byte[] data)
	{
		stringsWritten.addElement(new String(data));
	}
	/**
	 * save a string of data to the stream vector.
	**/
	public void write(byte[] data, int start, int offset)
	{
		stringsWritten.addElement(new String(data,start,offset));
	}
	/**
	 * save an intger to the stream vector.
	**/
	public void write(int i)
	{
		stringsWritten.addElement(Integer.toString(i));
	}
}