package macrolanguage;
import java.awt.*;

//ARTICLE6
/**
 * the VoidLayout is a layout manager whos purpose is to prevent
 * layout's from interfearing with the ordering of the components.
 * The VoidLayout solves the problem in the FreeFormEdit where the
 * user resized the Form and the LayoutManager sorted out all the
 * components.
 * Most of the implementation of a layout manager is empty in any
 * case and since this is a null layout then it is almost totaly
 * empty.
**/
class VoidLayout implements LayoutManager
{
	public void addLayoutComponent(String name, Component c)
	{
	}

	public void removeLayoutComponent(Component c)
	{
	}

	/**
	 * returns the Containers preferred size, which was set by the user.
	**/
	public java.awt.Dimension preferredLayoutSize(Container c)
	{
		return(new Dimension(width, height));
	}

	/**
	 * returns the Containers minimum size, which is currently the same
	 * as the preferred size
	**/
	public java.awt.Dimension minimumLayoutSize(Container c)
	{
		return(preferredLayoutSize(c));
	}

	public void layoutContainer(Container c)
	{
	}

	/**
	 * set the Containers preferred and minimum size's.
	**/
	public void setSize(int width,int height)
	{
		this.width  = width;
		this.height = height;
	}

	private int width,height; // the preferred height and width of the container.
}

